#ifndef READKEY_H
#define READKEY_H
/*
 * TEA Total Copyright (c) Alex Holden <alex@linuxhacker.org> 2000.
 *
 * This code is public domain; you can do whatever you want with it, though I
 * would prefer you to contribute any bug fixes back to me if possible.
 * This software comes with NO WARRANTY WHATSOEVER, not even the implied
 * warranties of merchantability and fitness for a particular purpose.
 */

#define KEY_HEADER "TEAK"
#if BYTE_ORDER == LITTLE_ENDIAN
#define KEY_MAGIC 0x53534150
#else
#define KEY_MAGIC 0x50415353
#endif
#define KEY_LENGTH (sizeof(KEY_HEADER) + (20 * 2))

#define KEY_NOENC '1'
#define KEY_TEAENC '2'

#define KEY_MD5_ITERATIONS 32

#define READKEY_REQ_MSG "Enter key password: "
#define READKEY_REQ_MSG2 "Re-enter password for verification: "

extern void read_pass(teastate *state, u32 *key, int in, int confirm);
extern void read_key(teastate *state);

#endif
